//------------------------------------------------------------------------------
// PROGRAMM: STL_VECTOR_04                                                     -
//------------------------------------------------------------------------------
// Beispielprogramm zur Verwendung der Standard Template Library (STL)         -
// Verwendung von VECTOREN (dynamische Arrays)                                 -
//------------------------------------------------------------------------------
// Einfaches Einlesen auf einen Vector und Ausgabe ber Index und Iterator     -
// mit einer eigenen Klasse (Datentyp)                                         -
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Standard-Header-Einbindung (alphabetisch)                                   -
//------------------------------------------------------------------------------
#include <iomanip.h>
#include <iostream.h>
#include <strstrea.h>

//------------------------------------------------------------------------------
// Header-Einbindung (alphabetisch)                                            -
//------------------------------------------------------------------------------
#include "HQG_Person.h"

//------------------------------------------------------------------------------
// Ab hier Vorcompilierung und Caching von Headern stoppen, da die Header der  -
// STL Codedefinitionen und nicht nur -deklarationen enthalten                 -
// #pragma hdrstop entfernt das Warning:                                       -
//                                                                             -
//    xxx.h(nnn,n):Cannot create pre-compiled header: code in header           -
//                                                                             -
// Alle Header die KEINE Codedefinitionen enthalten sind vor dem Pragma einzu- -
// binden                                                                      -
//------------------------------------------------------------------------------
#pragma hdrstop
#include <algorith>
#include <vector>     // dynamische Arrays
using namespace std;

//------------------------------------------------------------------------------
// Ja/Nein-Entscheidung anhand einer Characterliste                            -
//------------------------------------------------------------------------------
bool fnAsk (const char *szQuestion, const char *szTrueChars)
{
	char szBuffer [200];
	cout << szQuestion;
   cin.getline (szBuffer, 200);
   return (strchr (szTrueChars, szBuffer[0]) != 0);
}

//------------------------------------------------------------------------------
// Hauptprogramm                                                               -
//------------------------------------------------------------------------------
void main (void)
{
	//---------------------------------------------------------------------------
	// Variablen-Deklaration / -definition                                      -
	//---------------------------------------------------------------------------
   vector<HQGPerson> aMyIntVector;    // dynamisches Array vom Typ Person      -
   vector<HQGPerson>::iterator aIter; // Array-Iterator (Aufzhler) auf Person -
   HQGPerson   aEingabe;              // Eingabe-Puffer                        -
   bool        bEnde = false;

	//---------------------------------------------------------------------------
	// Einlesen der Arrayelemente                                               -
	//---------------------------------------------------------------------------
   while (!bEnde)
   {
		//------------------------------------------------------------------------
      // Anders als bei statischen Arrays kann man nicht einfach direkt auf    -
      // dem Array einlesen, da das Array nur genau die Anzahl an Elementen    -
      // besitzt, die ihm bergeben worden sind. Daher mu man ber eine       -
      // Puffer-Variable (hier aEingabe) gehen, deren Inhalt nach dem Einlesen -
      // an den Vector bergeben wird                                          -
		// Die Vector-Methode PUSH_BACK fgt die Person am ENDE des dynamischen  -
      // Arrays an                                                             -
		//------------------------------------------------------------------------
      aEingabe.ConsoleInput();
		aMyIntVector.push_back (aEingabe);

      bEnde = fnAsk ("\nEingabe beenden (j/n) : ", "jJyY+");
   }

	//---------------------------------------------------------------------------
	// Sortierung ber generischen Algorithmus der STL (Quicksort)              -
   // Dazu ist es ntig die Grenzen des dynamischen Arrays als Iteratoren fr  -
   // den Start- und Endpunkt der Sortierung anzugeben. Der zu sortierende Be- -
   // reich mu nicht zwangslufig das gesamte Array umfassen, auch Teil-      -
   // bereiche sind mglich.                                                   -
	//---------------------------------------------------------------------------
  	sort (aMyIntVector.begin(), aMyIntVector.end());

	//---------------------------------------------------------------------------
	// Ausgabe der Arrayelemente ber Iterator (Aufzhler)                      -
	//---------------------------------------------------------------------------
  	cout << endl << "gespeicherte Werte (Iterator-Zugriff): " << endl;
   for (aIter=aMyIntVector.begin(); aIter<aMyIntVector.end(); aIter++)
   {
   	cout << "Name: " << aIter->GetNachname() << ", " << aIter->GetVorname()
           << endl;
   }

	//---------------------------------------------------------------------------
	// Verhindern, das das DOS-Fenster bei Programmende sofort geschlossen wird -
	//---------------------------------------------------------------------------
   fnAsk ("\n\n--- Programmende ---", "");
}
